// ----------------------------------
// Filename      : MasterClock.java
// Created       : 17/05/2000
// Last modified : 17/05/2000
// Target        : Java VM
// Author        : Sven Maerivoet
//
// All rights reserved.
// Universitaire Instelling Antwerpen
// ----------------------------------

package mitrasim.simulator;

/** @author Sven Maerivoet<BR>
    All rights reserved.<BR>
    Universitaire Instelling Antwerpen
*/
public class MasterClock
{
  // internal datastructures
  private int fClockticks;

  public MasterClock()
  {
    fClockticks = 0;
  }

  public void set(int Hours, int Minutes, int Seconds, int TenthsOfSeconds)
  {
    fClockticks = TenthsOfSeconds +
                  (Seconds * 10) +
                  (Minutes * 10 * 60) +
                  (Hours * 10 * 60 * 60);
  }

  public void set(int Clockticks)
  {
    fClockticks = Clockticks;
  }

  public int get()
  {
    return fClockticks;
  }

  public static String translate(int Clockticks)
  {
    // filter out the days when a 24-hour cycle has completed
    Clockticks = Clockticks % (10 * 60 * 60 * 24);

    // calculate the hours, minutes, seconds and tenths of seconds
    int Hours = Clockticks / (10 * 60 * 60);
    Clockticks = Clockticks % (10 * 60 * 60);

    int Minutes = Clockticks / (10 * 60);
    Clockticks = Clockticks % (10 * 60);

    int Seconds = Clockticks / 10;
    Clockticks = Clockticks % 10;

    int TenthsOfSeconds = Clockticks;

    // concatenate these values into a string (zero padded)
    String TimeString = "";

    if (Hours < 10) {
      TimeString = "0";
    }
    TimeString += String.valueOf(Hours) + ":";

    if (Minutes < 10) {
      TimeString = TimeString + "0";
    }
    TimeString += String.valueOf(Minutes) + ":";

    if (Seconds < 10) {
      TimeString = TimeString + "0";
    }
    TimeString += String.valueOf(Seconds) + "." +
                  String.valueOf(TenthsOfSeconds);

    return TimeString;
  }

  public void advance()
  {
    ++fClockticks;
  }
}
