// ------------------------------------
// Filename      : ConfirmationBox.java
// Created       : 22/01/2000
// Last modified : 24/01/2000
// Target        : Java VM
// Author        : Sven Maerivoet
//
// All rights reserved.
// Universitaire Instelling Antwerpen
// ------------------------------------

package mitrasim.util;

import java.awt.*;
import java.awt.event.*;
import mitrasim.resources.*;

/** @author Sven Maerivoet<BR>
    All rights reserved.<BR>
    Universitaire Instelling Antwerpen
*/
public class ConfirmationBox extends Dialog implements WindowListener, ActionListener
{
  // internal datastructures
  private Messages fMessages;
  private boolean  fConfirmed;
  private String   fNo;
  private String   fYes;

  public ConfirmationBox(Frame parent, String message, String yes, String no)
  {
    super(parent);

    fMessages = (new Resources()).fMessages;

    // adjust the windowlayout
    setFont(new Font(fMessages.lookup("textFontName"),Font.PLAIN,14));
    setResizable(false);
    Point Org = parent.getLocation();
    setLocation(Org.x + 20,Org.y + 60);
    setBackground(Color.lightGray);
    setForeground(Color.black);
    setModal(true);
    setTitle("");
    fConfirmed = false;
    fYes = yes;
    fNo = no;

    // create the message- and controlpanel
    Panel MessagePanel = new Panel();
    Panel ControlPanel = new Panel();
    MessagePanel.setLayout(new GridLayout(3,1));
    ControlPanel.setLayout(new GridLayout(1,2));

    MessagePanel.add(new Label());
    MessagePanel.add(new Label(message,Label.CENTER));
    MessagePanel.add(new Label());

    Button button;

    button = new Button(fNo);
    button.addActionListener(this);
    ControlPanel.add(button);

    button = new Button(fYes);
    button.addActionListener(this);
    ControlPanel.add(button);

    setLayout(new BorderLayout());
    add("North",MessagePanel);
    add("South",ControlPanel);

    // add the windowlistener
    addWindowListener(this);

    pack();
    show();
  }

  public boolean confirmed()
  {
    return fConfirmed;
  }

  // methods from the WindowListener-interface
  public void windowOpened(WindowEvent e) { }
  public void windowClosing(WindowEvent e)
  {
    dispose();
  }
  public void windowClosed(WindowEvent e) { }
  public void windowIconified(WindowEvent e) { }
  public void windowDeiconified(WindowEvent e) { }
  public void windowActivated(WindowEvent e) { }
  public void windowDeactivated(WindowEvent e) { }
  
  // method from the ActionListener-interface
  public void actionPerformed(ActionEvent e)
  {
    String Command = e.getActionCommand();

    if (Command.equals(fNo)) {
      windowClosing(null);
    }

    if (Command.equals(fYes)) {
      fConfirmed = true;
      windowClosing(null);
    }
  }
}
